
/********************************** (C) COPYRIGHT *******************************
* File Name          :Key.C
* Author             : WCH
* Version            : V1.0
* Date               : 2017/01/20
* Description        : CH554ģ̣ڽתɼֵϴ
*******************************************************************************/

#include "./Public/CH554.H"                                                      
#include "./Public/DEBUG.H"
#include <string.h>
#include <stdio.h>

#define THIS_ENDP0_SIZE         DEFAULT_ENDP0_SIZE
#define CapsLockLED 0x02
#define BUFMAX 16

UINT8X  Ep0Buffer[8>(THIS_ENDP0_SIZE+2)?8:(THIS_ENDP0_SIZE+2)] _at_ 0x0000;    //˵0 OUT&INżַ
UINT8X  Ep1Buffer[64>(MAX_PACKET_SIZE+2)?64:(MAX_PACKET_SIZE+2)] _at_ 0x000a;  //˵1 IN,żַ
UINT8   SetupReq,SetupLen,Ready,Count,FLAG,UsbConfig,LED_VALID;
PUINT8  pDescr;                                                                //USBñ־
USB_SETUP_REQ   SetupReqBuf;                                                   //ݴSetup
bit Ep2InKey;
#define UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)
#define DEBUG 0
#pragma  NOAREGS
/*豸*/
UINT8C DevDesc[18] = {0x12,0x01,0x10,0x01,0x00,0x00,0x00,0x08,
                      0x3d,0x41,0x07,0x21,0x00,0x00,0x00,0x00,
                      0x00,0x01
                     };
UINT8C CfgDesc[59] =
{
    0x09,0x02,0x22,0x00,0x01,0x01,0x00,0xA0,0x32,             //
    0x09,0x04,0x00,0x00,0x01,0x03,0x01,0x01,0x00,             //ӿ,
    0x09,0x21,0x11,0x01,0x00,0x01,0x22,0x3e,0x00,             //HID
    0x07,0x05,0x81,0x03,0x08,0x00,0x0a,                       //˵
};
/*ַ*/
/*HID౨*/
UINT8C KeyRepDesc[62] =
{
    0x05,0x01,0x09,0x06,0xA1,0x01,0x05,0x07,
    0x19,0xe0,0x29,0xe7,0x15,0x00,0x25,0x01,
    0x75,0x01,0x95,0x08,0x81,0x02,0x95,0x01,
    0x75,0x08,0x81,0x01,0x95,0x03,0x75,0x01,
    0x05,0x08,0x19,0x01,0x29,0x03,0x91,0x02,
    0x95,0x05,0x75,0x01,0x91,0x01,0x95,0x06,
    0x75,0x08,0x26,0xff,0x00,0x05,0x07,0x19,
    0x00,0x29,0x91,0x81,0x00,0xC0
};

/**/
UINT8 HIDKey[8] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
UINT8 DataBuffer[BUFMAX];
UINT8 DataLen =0;
UINT8 RecvPoint =0;
UINT8 SendPoint =0;


/*******************************************************************************
* Function Name  : USBDeviceInit()
* Description    : USB豸ģʽ,豸ģʽշ˵ãжϿ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDeviceInit()
{
	  IE_USB = 0;
	  USB_CTRL = 0x00;                                                           // 趨USB豸ģʽ
    UEP0_DMA = Ep0Buffer;                                                      //˵0ݴַ
    UEP1_DMA = Ep1Buffer;                                                      //˵1ݴַ
    UEP4_1_MOD = ~(bUEP4_RX_EN | bUEP4_TX_EN |bUEP1_RX_EN | bUEP1_BUF_MOD) | bUEP4_TX_EN;//˵164ֽշ,˵0շ
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;                                 //OUT񷵻ACKIN񷵻NAK
    UEP1_CTRL = bUEP_T_TOG | UEP_T_RES_NAK;
		
	  USB_DEV_AD = 0x00;
	  UDEV_CTRL = bUD_PD_DIS;                                                    // ֹDP/DM
	  USB_CTRL = bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;                      // USB豸DMAжڼжϱ־δǰԶNAK
	  UDEV_CTRL |= bUD_PORT_EN;                                                  // USB˿
	  USB_INT_FG = 0xFF;                                                         // жϱ־
	  USB_INT_EN = bUIE_SUSPEND | bUIE_TRANSFER | bUIE_BUS_RST;
	  IE_USB = 1;
}
/*******************************************************************************
* Function Name  : Enp1IntIn()
* Description    : USB豸ģʽ˵1жϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Enp1IntIn( )
{
    memcpy( Ep1Buffer, HIDKey, sizeof(HIDKey));                              //ϴ
    UEP1_T_LEN = sizeof(HIDKey);                                             //ϴݳ
    UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;                //ʱϴݲӦACK
}

/*******************************************************************************
* Function Name  : DeviceInterrupt()
* Description    : CH554USBжϴ
*******************************************************************************/
void    DeviceInterrupt( void ) interrupt INT_NO_USB using 1                      //USBжϷ,ʹüĴ1
{
    UINT8 len;
    if(UIF_TRANSFER)                                                            //USBɱ־
    {
        switch (USB_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP))
        {
        case UIS_TOKEN_IN | 2:                                                  //endpoint 2# ж϶˵ϴ
            UEP2_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
//            UEP1_CTRL ^= bUEP_T_TOG;                                          //ԶתҪֶת
            UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            break;
        case UIS_TOKEN_IN | 1:                                                  //endpoint 1# ж϶˵ϴ
            UEP1_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
//            UEP2_CTRL ^= bUEP_T_TOG;                                          //ԶתҪֶת
            UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            FLAG = 1;                                                           /*ɱ־*/
            break;
        case UIS_TOKEN_SETUP | 0:                                                //SETUP
            len = USB_RX_LEN;
            if(len == (sizeof(USB_SETUP_REQ)))
            {
                SetupLen = UsbSetupBuf->wLengthL;
                if(UsbSetupBuf->wLengthH || SetupLen > 0x7F )
                {
                    SetupLen = 0x7F;    // ܳ
                }
                len = 0;                                                        // ĬΪɹϴ0
                SetupReq = UsbSetupBuf->bRequest;								
                if ( ( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )/* HID */
                {
									switch( SetupReq ) 
									{
										case 0x01://GetReport
												 break;
										case 0x02://GetIdle
												 break;	
										case 0x03://GetProtocol
												 break;				
										case 0x09://SetReport										
												 break;
										case 0x0A://SetIdle
												 break;	
										case 0x0B://SetProtocol
												 break;
										default:
												 len = 0xFF;  								 					            /*֧*/					
												 break;
								  }	
                }
                else
                {//׼
                    switch(SetupReq)                                        //
                    {
                    case USB_GET_DESCRIPTOR:
                        switch(UsbSetupBuf->wValueH)
                        {
                        case 1:                                             //豸
                            pDescr = DevDesc;                               //豸͵Ҫ͵Ļ
                            len = sizeof(DevDesc);
                            break;
                        case 2:                                             //
                            pDescr = CfgDesc;                               //豸͵Ҫ͵Ļ
                            len = sizeof(CfgDesc);
                            break;
                        case 0x22:                                          //
                            if(UsbSetupBuf->wIndexL == 0)                   //ӿ0
                            {
                                pDescr = KeyRepDesc;                        //׼ϴ
                                len = sizeof(KeyRepDesc);
                                Ready = 1;                                  //иӿڣñ׼λӦһӿɺЧ
                                IE_UART1 = 1;//ж															
															
                            }
                            else
                            {
                                len = 0xff;                                 //ֻ2ӿڣ仰ִ
                            }
                            break;
                        default:
                            len = 0xff;                                     //ֵ֧߳
                            break;
                        }
                        if ( SetupLen > len )
                        {
                            SetupLen = len;    //ܳ
                        }
                        len = SetupLen >= 8 ? 8 : SetupLen;                  //δ䳤
                        memcpy(Ep0Buffer,pDescr,len);                        //ϴ
                        SetupLen -= len;
                        pDescr += len;
                        break;
                    case USB_SET_ADDRESS:
                        SetupLen = UsbSetupBuf->wValueL;                     //ݴUSB豸ַ
                        break;
                    case USB_GET_CONFIGURATION:
                        Ep0Buffer[0] = UsbConfig;
                        if ( SetupLen >= 1 )
                        {
                            len = 1;
                        }
                        break;
                    case USB_SET_CONFIGURATION:
                        UsbConfig = UsbSetupBuf->wValueL;
                        break;
                    case 0x0A:
                        break;
                    case USB_CLEAR_FEATURE:                                            //Clear Feature
                        if ( ( UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )// ˵
                        {
                            switch( UsbSetupBuf->wIndexL )
                            {
                            case 0x82:
                                UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                break;
                            case 0x81:
                                UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                break;
                            case 0x01:
                                UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_R_TOG | MASK_UEP_R_RES ) | UEP_R_RES_ACK;
                                break;
                            default:
                                len = 0xFF;                                            // ֵ֧Ķ˵
                                break;
                            }
                        }
                        else
                        {
                            len = 0xFF;                                                // Ƕ˵㲻֧
                        }
                        break;
                    case USB_SET_FEATURE:                                              /* Set Feature */
                        if( ( UsbSetupBuf->bRequestType & 0x1F ) == 0x00 )             /* 豸 */
                        {
                            if( ( ( ( UINT16 )UsbSetupBuf->wValueH << 8 ) | UsbSetupBuf->wValueL ) == 0x01 )
                            {
                                if( CfgDesc[ 7 ] & 0x20 )
                                {
                                    /* ûʹܱ־ */
                                }
                                else
                                {
                                    len = 0xFF;                                        /* ʧ */
                                }
                            }
                            else
                            {
                                len = 0xFF;                                            /* ʧ */
                            }
                        }
                        else if( ( UsbSetupBuf->bRequestType & 0x1F ) == 0x02 )        /* ö˵ */
                        {
                            if( ( ( ( UINT16 )UsbSetupBuf->wValueH << 8 ) | UsbSetupBuf->wValueL ) == 0x00 )
                            {
                                switch( ( ( UINT16 )UsbSetupBuf->wIndexH << 8 ) | UsbSetupBuf->wIndexL )
                                {
                                case 0x82:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL;/* ö˵2 IN STALL */
                                    break;
                                case 0x02:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_R_TOG) | UEP_R_RES_STALL;/* ö˵2 OUT Stall */
                                    break;
                                case 0x81:
                                    UEP1_CTRL = UEP1_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL;/* ö˵1 IN STALL */
                                    break;
                                default:
                                    len = 0xFF;                               //ʧ
                                    break;
                                }
                            }
                            else
                            {
                                len = 0xFF;                                   //ʧ
                            }
                        }
                        else
                        {
                            len = 0xFF;                                      //ʧ
                        }
                        break;
                    case USB_GET_STATUS:
                        Ep0Buffer[0] = 0x00;
                        Ep0Buffer[1] = 0x00;
                        if ( SetupLen >= 2 )
                        {
                            len = 2;
                        }
                        else
                        {
                            len = SetupLen;
                        }
                        break;
                    default:
                        len = 0xff;                                           //ʧ
                        break;
                    }
                }
            }
            else
            {
                len = 0xff;                                                   //ȴ
            }
            if(len == 0xff)
            {
                SetupReq = 0xFF;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL
            }
            else if(len <= 8)                                                //ϴݻ״̬׶η0Ȱ
            {
                UEP0_T_LEN = len;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1ӦACK
            }
            else
            {
                UEP0_T_LEN = 0;  //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1,ӦACK
            }
            break;
        case UIS_TOKEN_IN | 0:                                               //endpoint0 IN
            switch(SetupReq)
            {
            case USB_GET_DESCRIPTOR:
                len = SetupLen >= 8 ? 8 : SetupLen;                          //δ䳤
                memcpy( Ep0Buffer, pDescr, len );                            //ϴ
                SetupLen -= len;
                pDescr += len;
                UEP0_T_LEN = len;
                UEP0_CTRL ^= bUEP_T_TOG;                                     //ͬ־λת
                break;
            case USB_SET_ADDRESS:
                USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            default:
                UEP0_T_LEN = 0;                                              //״̬׶жϻǿϴ0ݰƴ
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            }
            break;
        case UIS_TOKEN_OUT | 0:  // endpoint0 OUT
            len = USB_RX_LEN;
            if((SetupReq == 0x09)&& (len == 1))
            {
              LED_VALID = Ep0Buffer[0];							
            }
            else if((SetupReq == 0x09) && (len == 8)){//SetReport						 
            }							
            UEP0_T_LEN = 0;  //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
            UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA0,ӦACK
            break;
        default:
            break;
        }
        UIF_TRANSFER = 0;                                                 //д0ж
    }
    if(UIF_BUS_RST)                                                       //豸ģʽUSB߸λж
    {
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK;
        UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0;                                                 //жϱ־
    }
    if (UIF_SUSPEND)                                                     //USB߹/
    {
        UIF_SUSPEND = 0;
    }
    else {                                                               //ж,ܷ
        USB_INT_FG = 0xFF;                                               //жϱ־
    }
}

/*******************************************************************************
* Function Name  : QueryUART1Interrupt(void)
* Description    : UART1жϷ
*******************************************************************************/
void  QueryUART1Interrupt( void ) interrupt INT_NO_UART1 using 2             //UART1жϷ,ʹüĴ1
{
    if(U1RI)
    {
        U1RI = 0;
        DataBuffer[RecvPoint++] = SBUF1;
        DataLen++;
        if(RecvPoint==BUFMAX) RecvPoint=0;			
    }
    U1TI = 0;
}

/*******************************************************************************
* Function Name  : KeyCodeCorrespond()
* Description    : ȶԱֵӦֵ
* Input          : UINT8 keyCode 
* Output         : None
* Return         : None
*******************************************************************************/
void KeyCodeCorrespond(UINT8 keyCode)
{
	HIDKey[0] = 0; 
	if((keyCode>='a')&&(keyCode<='z')){                                       //ֵa-z
 
		if(LED_VALID&0x02)
		{
			FLAG = 0;
			HIDKey[2] = 0x39;
			Enp1IntIn();
			while(FLAG == 0);
			FLAG = 0;	
			memset(&HIDKey[0],0,8);
			Enp1IntIn();		
			while(FLAG == 0);				
		}
		keyCode -= 0x5D; 
		HIDKey[2] = keyCode; 		
		
	}
  else if((keyCode>='A')&&(keyCode<='Z')){			
		if((LED_VALID&0x02) == 0)
		{
			FLAG = 0;
			HIDKey[2] = 0x39;
			Enp1IntIn();
			while(FLAG == 0);
			FLAG = 0;	
			memset(&HIDKey[0],0,8);
			Enp1IntIn();		
			while(FLAG == 0);				
		}    
	  
	  
	  keyCode -= 0x3D; 
    HIDKey[2] = keyCode;  
//    HIDKey[0]	= 0x02;	                                                  //shift+		
   
  }
  else if((keyCode>='1')&&(keyCode<='9')){
		keyCode -= 0x13;                                                        //ĸּ
		HIDKey[2] = keyCode; 		
	}
	else if(keyCode=='0'){
		HIDKey[2] = 0x27; 		
	}		
	else if(keyCode <= 0x2f){		
		if(keyCode == 0x20){
			HIDKey[2] = 0x2C;                                                     //ո        
		}		
		else if(keyCode == 0x21){//'!'
			HIDKey[2] = 0x1E; 
			HIDKey[0]	= 0x02;	                                                  //shift+		
		}
		else if(keyCode == 0x22){//'"'
			HIDKey[2] = 0x34; 
			HIDKey[0]	= 0x02;	                                                  //shift+		
		}
		else if(keyCode == 0x23){//'#'
			HIDKey[2] = 0x20; 
			HIDKey[0]	= 0x02;	                                                  //shift+		
		}
		else if(keyCode == 0x24){//'$'
			HIDKey[2] = 0x21; 
			HIDKey[0]	= 0x02;	                                                  //shift+		
		}	
		else if(keyCode == 0x25){//'%'
			HIDKey[2] = 0x22; 
			HIDKey[0]	= 0x02;	                                                  //shift+		
		}
		else if(keyCode == 0x26){//'&'
			HIDKey[2] = 0x24; 
			HIDKey[0]	= 0x02;	                                                  //shift+		
		}
		else if(keyCode == 0x27){//'%'
			HIDKey[2] = 0x34; 	
		}
		else if(keyCode == 0x28){/*(*/
			HIDKey[2] = 0x26; 
			HIDKey[0]	= 0x02;	                                                  //shift+		
		}
		else if(keyCode == 0x29){/*)*/
			HIDKey[2] = 0x27; 
			HIDKey[0]	= 0x02;	                                                  //shift+		
		}
		else if(keyCode == 0x2a){/***/
			HIDKey[2] = 0x25; 
			HIDKey[0]	= 0x02;	                                                  //shift+		
		}
		else if(keyCode == 0x2b){/*+*/
			HIDKey[2] = 0x2e; 
			HIDKey[0]	= 0x02;	                                                  //shift+		
		}	
		else if(keyCode == 0x2c){/*,*/
			HIDKey[2] = 0x36; 	
		}	
		else if(keyCode == 0x2d){/*-*/
			HIDKey[2] = 0x2d; 	
		}	
		else if(keyCode == 0x2e){/*,*/
			HIDKey[2] = 0x37; 	
		}	
		else if(keyCode == 0x2f){/*/*/
			HIDKey[2] = 0x38; 		
		}		
  }
  else if(keyCode <= 0x3f){	
		if(keyCode == 0x3a){/*:*/
			HIDKey[2] = 0x33; 	
			HIDKey[0]	|= 0x02;	                                                  //shift+			
		}
		else if(keyCode == 0x3b){/*;*/
			HIDKey[2] = 0x33; 			
		}	
		else if(keyCode == 0x3c){/*<*/
			HIDKey[2] = 0x36; 	
			HIDKey[0]	|= 0x02;	                                                  //shift+			
		}
		else if(keyCode == 0x3d){/*=*/
			HIDKey[2] = 0x2e; 				
		}	
		else if(keyCode == 0x3e){/*>*/
			HIDKey[2] = 0x37; 	
			HIDKey[0]	|= 0x02;	                                                  //shift+			
		}
		else if(keyCode == 0x3f){/*?*/
			HIDKey[2] = 0x38; 	
			HIDKey[0]	|= 0x02;	                                                  //shift+			
		}
  }
  else if(keyCode == 0x40){/*@*/
    HIDKey[2] = 0x1f; 	
    HIDKey[0]	= 0x02;	                                                  //shift+			  
  }
  else if((keyCode >= 0x5b)&&(keyCode <= 0x60)){	
		if(keyCode == 0x5b){/*[*/
			HIDKey[2] = 0x2f; 			
		}	
		else if(keyCode == 0x5c){/*\*/
			HIDKey[2] = 0x31; 			
		}
		else if(keyCode == 0x5d){/*:*/
			HIDKey[2] = 0x30; 		
		}	
		else if(keyCode == 0x5e){/*:*/
			HIDKey[2] = 0x23; 	
			HIDKey[0]	= 0x02;	                                                  //shift+			
		}
		else if(keyCode == 0x5f){/*:*/
			HIDKey[2] = 0x2d; 	
			HIDKey[0]	= 0x02;	                                                  //shift+			
		}
		else if(keyCode == 0x60){/*`*/
			HIDKey[2] = 0x35; 			
		}	
	}
  else if((keyCode >= 0x7b)&&(keyCode <= 0x7f)){
		if(keyCode == 0x7b){/*{*/
			HIDKey[2] = 0x2f; 	
			HIDKey[0]	= 0x02;	                                                  //shift+			
		}
		else if(keyCode == 0x7c){/*|*/
			HIDKey[2] = 0x31; 	
			HIDKey[0]	= 0x02;	                                                  //shift+			
		}
		else if(keyCode == 0x7d){/*}*/
			HIDKey[2] = 0x30; 	
			HIDKey[0]	= 0x02;	                                                  //shift+			
		}
		else if(keyCode == 0x7e){/*~*/
			HIDKey[2] = 0x35; 	
			HIDKey[0]	= 0x02;	                                                  //shift+			
		}
		else if(keyCode == 0x7f){/*{*/
			HIDKey[2] = 0x4c; 			
		}
	}
  else if((keyCode >= 0x80)&&(keyCode <= 0x87)){/*left ctl*/	
    keyCode &= 0x0f; 
    HIDKey[0]	= (1<<keyCode);	                                          //			
  }
  else if((keyCode >= 0xd7)&&(keyCode <= 0xda)){/**/
    keyCode -= 0x88; 		
    HIDKey[2]	= keyCode;	                                         	
  }
  else if((keyCode >= 0xb0)&&(keyCode <= 0xb3)){/**/
    keyCode -= 0x88; 		
    HIDKey[2]	= keyCode;	
  }
  else if((keyCode >= 0xd1)&&(keyCode <= 0xd5)){/**/
    keyCode -= 0x88; 		
    HIDKey[2]	= keyCode;	                                         	
  }
  else if((keyCode >= 0xC1)&&(keyCode <= 0xCD)){/**/
    keyCode -= 0x88; 		
    HIDKey[2]	= keyCode;	                                         	
  }

}


void HIDValueHandle()
{
	DataLen--;	

	KeyCodeCorrespond(DataBuffer[SendPoint]);
	
	SendPoint++;
	if(SendPoint>=BUFMAX) SendPoint=0;

	FLAG = 0;
	Enp1IntIn();
	while(FLAG == 0);
	FLAG = 0;	
	memset(&HIDKey[0],0,8);
	Enp1IntIn();		
	while(FLAG == 0);		
	
}

main()
{
    CfgFsys( );                                                           //CH559ʱѡ
    mDelaymS(5);                                                          //޸Ƶȴڲȶ,ؼ	
    mInitSTDIO( );                                                        //0ʼ	
    printf("start\n");
	USBDeviceInit();                                                      //USB豸ģʽʼ
    UART1Setup();
    EA = 1;                                                               //Ƭж
    IP_EX = bIP_UART1;//ȵȼ
    UEP1_T_LEN = 0;                                                       //Ԥʹ÷ͳһҪ
    FLAG = 0;
    Ready = 0;
	LED_VALID = 1;   //һĬֵ
    while(1)
    {
        if(Ready&&(DataLen>0))
        {
            HIDValueHandle();
        }
    }
}
